--  questa unit generica consente di istanziare diverse variet di strutture
--+ dati, viste come vettori unidimensionali di valori di uno stesso tipo, sia
--+ rispetto al tipo (che istanzier "Elemento") che rispetto all'ampiezza
--+ (range <>)
generic
   type Elemento is private;
package Risorsa_Generica is

   type Struttura_Dati is array (Positive range <>) of Elemento;
   --  il package conterra' una specifica istanza di struttura dati (Area_Dati)
   --  acceduta tramite una struttura di tipo "protetto", le cui operazioni
   --  corrispondono ai metodi synchronized di Java, ma la cui semantica e'
   --  tutta racchiusa nel "runtime"

   protected type Risorsa (Capienza : Natural) is
      entry Inserisci (Prodotto : in     Elemento);
      entry Preleva   (Prodotto :    out Elemento);
   private
      --  tutte le variabili dichiarate in questa sezione sono manipolabili
      --  solo da operazioni interne al tipo Risorsa
      Area_Dati   : Struttura_Dati (1 .. Capienza);
      Testa, Coda : Positive := 1;
      Contenuto   : Natural := 0;
   end Risorsa;

end Risorsa_Generica;
